#include <Wire.h>
#include <string.h>
#include <stdio.h>
#define XSTICK 0      //The joystick values     
#define YSTICK 1

uint8_t outbuf[6];

int nunchuckValues[] = {0,0,0,0,0,0,0,0,0,0}; //An array to store the nuncheck values

int cnt = 0;
int ledPin = 13;

int servoPin = 7;
int servoPin2 = 6;

int pulseWidth = 0;
int pulseWidth2 = 0;

long lastPulse = 0;
long lastPulse2 = 0;

int z_button = 0;
int c_button = 0;

int refreshTime = 20;

int minPulse = 1000;
int minPulse2 = 500;

int dtime=10;

#define pwbuffsize 10
long pwbuff[pwbuffsize];
long pwbuffpos = 0;
long pwbuff2[pwbuffsize];
long pwbuffpos2 = 0;

void setup()
{
    Wire.begin ();
    nunchuck_init ();
    pinMode(servoPin, OUTPUT);
    pinMode(servoPin2, OUTPUT);

    pulseWidth = minPulse;
    pulseWidth2 = minPulse2;
    Serial.print ("Finished setup\n");
}

void nunchuck_init()
{
    Wire.beginTransmission (0x52);
    Wire.write (0x40);
    Wire.write (0x00);  
    Wire.endTransmission ();
}

void send_zero()
{
    Wire.beginTransmission (0x52);
    Wire.write (0x00);
    Wire.endTransmission ();
}

int t = 0;

void loop()
{
   t++;
    long last = millis();

    if( t == 1) {

        t = 0;

        Wire.requestFrom (0x52, 6);

        while (Wire.available ()) {
            outbuf[cnt] = nunchuk_decode_byte (Wire.read ());
            digitalWrite (ledPin, HIGH);
            cnt++;
        }

        if (cnt >= 5) {

        cnt = 0;
        send_zero();

    } // if(t==)

    updateServo();

    delay(dtime);
}

      
  
  else{
    moveWiiJoystick();
  }
}  

void updateServo() {

    if (millis() - lastPulse >= refreshTime) {

        digitalWrite(servoPin, HIGH);
        delayMicroseconds(pulseWidth);
        digitalWrite(servoPin, LOW);

        digitalWrite(servoPin2, HIGH);
        delayMicroseconds(pulseWidth2);
        digitalWrite(servoPin2, LOW);

        lastPulse = millis();
    }
}

int i=0;
//Serial for nunchuck goes here


char nunchuk_decode_byte (char x)
{
    x = (x ^ 0x17) + 0x17;
    return x;
}

void muovi (){
    float tilt = (700 - outbuf[3]*2*2);
    float tilt2 = outbuf[2]*2*2;

    tilt = (tilt);
    pulseWidth = (tilt * 5) + minPulse;

    tilt2 = (tilt2-288);
    pulseWidth2 = (tilt2 * 5) + minPulse2;

    pwbuff[pwbuffpos] = pulseWidth;
    pwbuff2[pwbuffpos2] = pulseWidth2;
    
    if( ++pwbuffpos == pwbuffsize ) pwbuffpos = 0;
    if( ++pwbuffpos2 == pwbuffsize ) pwbuffpos2 = 0;


    pulseWidth=0;
    pulseWidth2=0;

    for( int p=0; p<pwbuffsize; p++ ){
        pulseWidth += pwbuff[p];
        pulseWidth2 += pwbuff2[p];
    }

    pulseWidth /= pwbuffsize;
    pulseWidth2 /= pwbuffsize;

}

void moveWiiJoystick(){
 moveDifferential(map(getNunValue(YSTICK),30,220,-100,100),map(getNunValue(XSTICK),30,220,-100,100));
 }
 
 int getNunValue(int valueIndex){
  return nunchuckValues[valueIndex];
 }
 
 void moveDifferential(int speed1, int direction1){
  speed1 = deadBandFilter(speed1);
  direction1 = deadBandFilter(direction1);
  setSpeedLeft(speed1 + direction1);
  setSpeedRight(speed1 - direction1);
}

 if (cnt >= 5) {
        nunchuckValues[XSTICK] = outbuf[0];
        nunchuckValues[YSTICK] = outbuf[1];
        int tempNun_xAxis = outbuf[2] * 2 * 2; 
        int tempNun_yAxis = outbuf[3] * 2 * 2;  
        int tempNun_zAxis = outbuf[4] * 2 * 2;
        nunchuckValues[ZBUTTON] = 0;
        nunchuckValues[CBUTTON] = 0;

         // byte outbuf[5] contains bits for z and c buttons
         // it also contains the least significant bits for the accelerometer data
         // so we have to check each bit of byte outbuf[5]
        if ((outbuf[5] >> 0) & 1) { nunchuckValues[ZBUTTON] = 1; } //checking if Z button is pressed (0=pressed 1=unpressed)
        if ((outbuf[5] >> 1) & 1) { nunchuckValues[CBUTTON] = 1; } //checking if C button is pressed (0=pressed 1=unpressed)
        if ((outbuf[5] >> 2) & 1) { tempNun_xAxis += 2; } //adding second least significant bit to x_axis
        if ((outbuf[5] >> 3) & 1) { tempNun_xAxis += 1; } //adding least significant bit to x_axis
        if ((outbuf[5] >> 4) & 1) { tempNun_yAxis += 2; } //adding second least significant bit to y_axis
        if ((outbuf[5] >> 5) & 1) { tempNun_yAxis += 1; } //adding least significant bit to x_axis
        if ((outbuf[5] >> 6) & 1) { tempNun_zAxis += 2; } //adding second least significant bit to z_axis
        if ((outbuf[5] >> 7) & 1) { tempNun_zAxis += 1; } ////adding least significant bit to x_axis

        nunchuckValues[XAXISDELTA] = tempNun_xAxis - nunchuckValues[XAXIS];
        nunchuckValues[XAXIS] = tempNun_xAxis;
        nunchuckValues[YAXISDELTA] = tempNun_yAxis - nunchuckValues[YAXIS];
        nunchuckValues[YAXIS] = tempNun_yAxis;
        nunchuckValues[ZAXISDELTA] = tempNun_zAxis - nunchuckValues[ZAXIS];
        nunchuckValues[ZAXIS] = tempNun_zAxis;
    }
  cnt = 0;
  send_zero (); // send the request for next bytes
}

int deadBandFilter(int value){
 if(value > -DEADBAND && value < DEADBAND){value = 0;}
 else{
   if(value > 0){value = value - DEADBAND * 100 / (100-DEADBAND);}
   else{value = value + DEADBAND * 100 / (100-DEADBAND);}
 }
 return value; 
}
